/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "txs_hash.h"

#ifdef TXS_SUB_OP
#include "sub_op.h"
#endif

/*Change this if you care. Note that the memory used is this number
 multiplied by 256 again. The default is 256 * 256 == 65535 */

#define CHARTABLE_MAX 256

typedef unsigned char TXS_chartable_t[256];

#define txs_search_from_sv(sv) (struct TXS_Search*)(SvUVX(sv))
#define terms_from_search(srch) \
    (struct TXS_String*)(((char*)srch) + sizeof(struct TXS_Search))

#define TXS_COUNTERS

#ifdef TXS_COUNTERS
#define OPTIMIZE_STATS_FIELDS \
struct { \
    int opti_lengths; \
    int opti_chartable; \
    int opti_hash_firstpass; \
    int opti_hash_secondpass; \
    int opti_none; \
    int opti_8; \
    int opti_4; \
    int opti_2; \
} statistics ;

#define txs_inc_counter(srchp, v) \
    (srchp->statistics.opti_ ## v)++;

#define _txs_dumpstat(srchp, stat) \
    printf("%s: %d\n", "TXS Optimized: " #stat, srch->statistics.opti_ ## stat);

#define txs_dump_stats(srchp) \
    _txs_dumpstat(srchp, lengths); _txs_dumpstat(srchp, chartable); \
    _txs_dumpstat(srchp, hash_firstpass); _txs_dumpstat(srchp, hash_secondpass); \
    _txs_dumpstat(srch, none);
#else

#define OPTIMIZE_STATS_FIELDS
#define txs_inc_counter(a, b)
#define txs_dump_stats(a)

#endif


enum {
    TXSf_BAD_CHARTABLE = 1 << 0
};

typedef uint8_t TXS_termlen_t;

struct TXS_Search {    
    int flags;
    
    /*The number of prefixes*/
    int term_count;
    
    /*The minimum (or rather, maximum) common prefix length for all prefixes*/
    int min_len;
    
    /*The maximum length for a term*/
    int max_len;
    
    /*How many unique lengths*/
    int term_lengths_max;
    
    /*If being kept across threads, we make duplicate pointer
     references to our structure. This counter is set to one
     for new object creation, and then increased by one during
     each svt_dup, and decreased by one during svt_free*/
    int refcount;    
    
    /*Sparse array for checking the existence of a char in a given position
     for any term*/    
    TXS_chartable_t chartable[CHARTABLE_MAX];
        
    /*Static array of term_lengths_max lengths*/
    TXS_termlen_t term_lengths[CHARTABLE_MAX];
    
    /*Prefix tree - This is a hash which is checked in the first hash pass,
     and its keys are substrings of prefix, all exactly min_len length*/
    struct TXS_HashTable *ht_min;
    
    /*Full match index. This contains the actual prefixes in hash
     form, and is traversed on the second hash pass*/
    struct TXS_HashTable *ht_full;
        
    /*Optimizations and statistics*/
    OPTIMIZE_STATS_FIELDS;
};

static int txs_freehook(pTHX_ SV* mysv, MAGIC* mg);
static int txs_duphook(pTHX_ MAGIC *mg, CLONE_PARAMS *param);
static void THX_txs_sv_init(pTHX_ SV *mysv, struct TXS_Search *srch);
#define txs_sv_init(mysv, srch) THX_txs_sv_init(aTHX_ mysv, srch)

static MGVTBL txs_vtbl = {
    .svt_free = txs_freehook,
    .svt_dup = txs_duphook
};


typedef int(*txs_compar_fn_t)(const void*, const void*);

static int _compar(const TXS_termlen_t *i1, const TXS_termlen_t *i2)
{
    if(*i1 < *i2) {
        return -1;
    } else if ( *i1 == *i2 ) {
        die("Didn't expect to find equal!");
    } else {
        return 1;
    }
}

#define term_sanity_check(svpp, idx) \
    if(!svpp) { die("Terms list is partially empty at idx=%d", idx); } \
    if(SvROK(*svpp)) { die("Found reference in terms list at idx=%d", idx); } \
    if(sv_len(*svpp) > CHARTABLE_MAX ) { \
        die("Found string larger than %d at idx=%d", CHARTABLE_MAX, idx); \
    }

#define study_terms(srch, mortal_av) THX_study_terms(aTHX_ srch, mortal_av)
static void THX_study_terms(
    pTHX_
    struct TXS_Search *srch,
    AV *mortal_av)
{
    SV **old_sv = NULL;
    char *term_s = NULL;
    STRLEN term_len = 0;
    int i, j;
    int len_idx = 0;
    int sort_min = 0;
    
    int max = av_len(mortal_av);
    
    for(i = 0; i <= max; i++) {
        SV **old_sv = av_fetch(mortal_av, i, 0);
        term_sanity_check(old_sv, i);
        
        term_s = SvPV(*old_sv, term_len);
        for(j = 0; j < term_len; j++) {
            srch->chartable[j][(unsigned char)term_s[j]] = 1;
        }
        
        
        /*Avoid duplicates*/
        for(j = 0; j < len_idx; j++) {
            if(srch->term_lengths[j] == term_len) {
                j = -1;
                break;
            }
        }
        
        if(j == len_idx) {
            srch->term_lengths[len_idx++] = term_len;
        }
    }
    
    /*Sort the lengths list*/
    qsort(srch->term_lengths, len_idx, sizeof(TXS_termlen_t),
      (txs_compar_fn_t)&_compar);
    
    len_idx--;
    
    srch->term_lengths_max = len_idx;
    srch->max_len = srch->term_lengths[len_idx];
    srch->min_len = srch->term_lengths[0];
    
    srch->term_count = max;
    
    //build_chartable_cost(srch);
}

#define prefix_search_build(av) THX_prefix_search_build(aTHX_ av);
SV* THX_prefix_search_build(pTHX_ AV *mortal_av)
{
    int i = 0, j = 0;
    int max = av_len(mortal_av);
    int my_len = sizeof(struct TXS_Search);
	
    char *term_s = NULL;
    STRLEN term_len = 0;
    char *strlist_p = NULL;
        
    struct TXS_String *strp = NULL;
    struct TXS_Search *srch = NULL;
    struct TXS_String *terms = NULL;
    
    Newxz(srch, my_len, char);
    srch->refcount = 1;
    
    SV *mysv = newSVuv((UV)srch);
    HV *fullmatch = newHV();
    HV *trie = newHV();
	
	HV *stash;
	SV *blessed;
        
    study_terms(srch, mortal_av);
	
    for(i = 0; i <= max; i++) {
        SV **a_term = av_fetch(mortal_av, i, 0);
        term_s = SvPV(*a_term, term_len);
        hv_store(fullmatch, term_s, term_len, &PL_sv_undef, 0);
        hv_store(trie, term_s, srch->min_len, &PL_sv_undef, 0);
        
    }
    
    srch->ht_full = txs_ht_build(fullmatch);
    srch->ht_min = txs_ht_build(trie);
    
    SvREFCNT_dec(fullmatch);
    SvREFCNT_dec(trie);
    	
    /*Study the chartable, and see if it's worthwhile performing
     lookups against it*/
    txs_sv_init(mysv, srch);
	blessed = newRV_noinc(mysv);
	stash = gv_stashpv("Text::Prefix::XS", 0);
	if(!stash) {
		die("Couldn't get stash!");
	}
	sv_bless(blessed, stash);
	return blessed;
}

#define prefix_search(mysv, input_sv) THX_prefix_search(aTHX_ mysv, input_sv)
SV* THX_prefix_search(pTHX_ SV* mysv, SV *input_sv)
{
    register int i = 1, j = 0;

    SV *ret = &PL_sv_undef;
    
    register struct TXS_String *strp;
    register int strp_len;
    STRLEN input_len;
    
    register int term_len;
    int match_len = 0;
    int can_match = 0;
    
    char *input = SvPV(input_sv, input_len);
    if(!SvROK(mysv)) {
        die("Not a valid search blob");
    }
    struct TXS_Search *srch = txs_search_from_sv(SvRV(mysv));
    struct TXS_String *terms = terms_from_search(srch);
    
    if(input_len < srch->term_lengths[0]) {
        /*Too short!*/
        goto GT_RET;
    }
    
    /*FIRST PASS:
     * Check all prefix lengths, and see if we're eligible for any*/
    for(i = 0; i <= srch->term_lengths_max; i++) {
        term_len = srch->term_lengths[i];
        
        if(term_len > input_len) {
            break;
        }
        
        /*We can. Break*/
        if(srch->chartable[term_len-1][ (unsigned char)input[term_len-1] ]) {
            can_match = 1;
            break;
        }
    }
    
    if(!can_match) {
        txs_inc_counter(srch, lengths);
        goto GT_RET;
    }

    /* SECOND PASS:
     * In our little game of hangman, we know the that we have a last character
     * for at least one prefix.
     *
     * Now, check for non-existent characters in any of the rest of the
     * prefixes, for the smallest prefix size
    */
    for(i = 0; i < srch->min_len; i++) {
        if(!srch->chartable[i][ (unsigned char)input[i] ]) {
            txs_inc_counter(srch, chartable);
            goto GT_RET;
        }
    }

    /*THIRD PASS:
     * Check if the sequence up to the minimum prefix length is valid*/
    if(!txs_ht_check(srch->ht_min, input, srch->min_len)) {
        txs_inc_counter(srch, hash_firstpass);
        goto GT_RET;
    }
    
    /*FOURTH PASS:
     * Check if we have a valid full prefix. If can_match ends up being true, 
     * it essentially means we will ALWAYS have a match*/
    can_match = 0;
    for(i = 0; i <= srch->term_lengths_max; i++) {
        term_len = srch->term_lengths[i];
        if(term_len > input_len) {
            warn("Too short!");
            break;
        }
        
        if(txs_ht_check(srch->ht_full, input, term_len)) {
            can_match = 1;
            break;
        }
    }
    
    if(!can_match) {
        txs_inc_counter(srch, hash_secondpass);
        goto GT_RET;
    }

    match_len = term_len;
    for(j = srch->term_lengths_max; j > i; j--) {
        term_len = srch->term_lengths[j];
        if(term_len > input_len) { 
            continue;
        }

        if(txs_ht_check(srch->ht_full, input, term_len)) {
            match_len = term_len;
            break;
        }
    }
    ret = newSVpv(input, match_len);
    if(SvUTF8(input_sv)) {
        SvUTF8_on(ret);
    }
    goto GT_RET;
	
    GT_RET:
    return ret;        
}

#define _print_optimized(v) printf("%s: %d\n", #v, (Optimized_ ## v))


#define prefix_search_multi(mysv, input_strings) \
    THX_prefix_search_multi(aTHX_ mysv, input_strings)
SV* THX_prefix_search_multi(pTHX_ SV* mysv, AV *input_strings)
{
    int i = 0;
    int max = av_len(input_strings);
    HV *ret = newHV();
    
    SV **cur_sv;
    AV *tmpav = NULL;
    SV *prefix = NULL;
    HE *prefix_ret_ent = NULL;
    
    for(i = 0; i <= max; i++) {
        cur_sv = av_fetch(input_strings, i, 0);
        
        if(!cur_sv || (!SvPV_nolen(*cur_sv)) ) {
            /*Non existent or not a string. We don't care about SvPV since it's
            gonna get converted anyway*/
            continue;
        }
        
        prefix = prefix_search(mysv, *cur_sv);
        if(prefix == &PL_sv_undef) {
            continue;
        }
                
        prefix_ret_ent = hv_fetch_ent(ret, prefix, 0, 0);
        if(!prefix_ret_ent) {
            prefix_ret_ent = hv_store_ent(
                        ret, prefix, newRV_noinc((SV*)newAV()), 0);
        }
        
        tmpav = SvRV(HeVAL(prefix_ret_ent));
        av_store(tmpav, av_len(tmpav)+1, newSVsv(*cur_sv));
    }
    return newRV_noinc((SV*)ret);
}

#ifdef TXS_SUB_OP
static OP* TXS_OP_psearch(pTHX)
{
    dXSARGS;
    SV *input = POPs;
    SV *mysv = POPs;
    SV *ret = prefix_search(mysv, input);
    PUSHs(ret);
    XSRETURN(1);
}
#endif

#define prefix_search_dump(mysv) THX_prefix_search_dump(aTHX_ mysv)
SV* THX_prefix_search_dump(pTHX_ SV *mysv)
{
    if(!SvROK(mysv)) {
        die("Bad parameter!");
    }
    
    struct TXS_Search *srch = txs_search_from_sv(SvRV(mysv));
    txs_dump_stats(srch);
	
	printf("ht_min: ");
	txs_ht_dump_stats(srch->ht_min);
	
	printf("ht_full: ");
	txs_ht_dump_stats(srch->ht_full);
	
    return &PL_sv_undef;
}

static int txs_freehook(pTHX_ SV *mysv, MAGIC *mg)
{
    struct TXS_Search *srch = (struct TXS_Search*)mg->mg_ptr;
    if(PL_dirty) {
        return 0;
    }
    
    if(!srch) {
        warn("TXS_Search object has already been freed?");
        return 0;
    }
    
    srch->refcount--;
    
    //warn("srch->refcount: %d", srch->refcount);
    
    if(!srch->refcount) {
        //warn("TXS: Search being destroyed..");
        txs_ht_free(srch->ht_full);
        txs_ht_free(srch->ht_min);
        Safefree(srch);
        mg->mg_ptr = NULL;
    }
}

static int txs_duphook(pTHX_ MAGIC *mg, CLONE_PARAMS *param)
{
    struct TXS_Search *srch = txs_search_from_sv(mg->mg_obj);
    srch->refcount++;
}

static void THX_txs_sv_init(pTHX_ SV *mysv, struct TXS_Search *srch)
{
    MAGIC *mg = sv_magicext(mysv, mysv,
                PERL_MAGIC_ext, &txs_vtbl,
                (char*)srch, 0);
    srch->refcount = 1;
    mg->mg_flags |= MGf_DUP;    
}

#line 475 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 619 "XS.c"

XS_EUPXS(XS_Text__Prefix__XS_prefix_search_build); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Prefix__XS_prefix_search_build)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "av_terms");
    {
	AV *	av_terms;
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    av_terms = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Text::Prefix::XS::prefix_search_build",
				"av_terms");
		}
	} STMT_END
;

	RETVAL = prefix_search_build(av_terms);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Prefix__XS_prefix_search); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Prefix__XS_prefix_search)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "mysv, input");
    {
	SV *	mysv = ST(0)
;
	SV *	input = ST(1)
;
	SV *	RETVAL;

	RETVAL = prefix_search(mysv, input);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Prefix__XS_prefix_search_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Prefix__XS_prefix_search_multi)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "mysv, input_strings");
    {
	SV *	mysv = ST(0)
;
	AV *	input_strings;
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    input_strings = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Text::Prefix::XS::prefix_search_multi",
				"input_strings");
		}
	} STMT_END
;

	RETVAL = prefix_search_multi(mysv, input_strings);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Prefix__XS_prefix_search_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Prefix__XS_prefix_search_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "mysv");
    {
	SV *	mysv = ST(0)
;
	SV *	RETVAL;

	RETVAL = prefix_search_dump(mysv);
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Text__Prefix__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__Prefix__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Text::Prefix::XS::prefix_search_build", XS_Text__Prefix__XS_prefix_search_build);
        (void)newXSproto_portable("Text::Prefix::XS::prefix_search", XS_Text__Prefix__XS_prefix_search, file, "$$");
        (void)newXSproto_portable("Text::Prefix::XS::prefix_search_multi", XS_Text__Prefix__XS_prefix_search_multi, file, "$\\@");
        (void)newXSproto_portable("Text::Prefix::XS::prefix_search_dump", XS_Text__Prefix__XS_prefix_search_dump, file, "$");

    /* Initialisation Section */

#line 468 "XS.xs"
{
#ifdef TXS_SUB_OP
     sub_op_config_t c;
     c.name    = "psearch";
     c.namelen = sizeof("psearch")-1;
     c.pp      = TXS_OP_psearch;
     c.check   = 0;
     c.ud      = NULL;
     sub_op_register(aTHX_ &c);
#else
     ;
#endif
}

#line 776 "XS.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

